B<mr> is a Multiple Repository management tool. It can checkout, update, or
perform other actions on a set of repositories as if they were one combined
repository. It supports any combination of subversion, git, cvs, mercurial,
-bzr and darcs repositories, and support for other revision control systems can
-easily be added.
+bzr, darcs and fossil repositories, and support for other revision
+control systems can easily be added.
B<mr> cds into and operates on all registered repositories at or below your
working directory. Or, if you are in a subdirectory of a repository that
Be quiet.
+=item -k
+
+=item --insecure
+
+Accept untrusted SSL certificates when bootstrapping.
+
=item -s
=item --stats
=back
-=head1 "MRCONFIG FILES"
+=head1 MRCONFIG FILES
Here is an example .mrconfig file:
command, this can be a useful way to define shell functions for other commands
to use.
+=item fixups
+
+If the "fixups" parameter is set, its command is run whenever a repository
+is checked out, or updated. This provides an easy way to do things
+like permissions fixups, or other tweaks to the repository content,
+whenever the repository is changed.
+
+=item pre_ and post_
+
+If a "pre_action" parameter is set, its command is run before mr performs the
+specified action. Similarly, "post_action" parameters are run after mr
+successfully performs the specified action. For example, "pre_commit" is
+run before committing; "post_update" is run after updating.
+
=back
When looking for a command to run for a given action, mr first looks for
or even to add other commands for 'mr online' to run. If the file is
present, mr assumes it is in offline mode.
-=head "UNTRUSTED MRCONFIG FILES"
+=head1 UNTRUSTED MRCONFIG FILES
Since mrconfig files can contain arbitrary shell commands, they can do
-anything. This flexability is good, but it also allows a malicious mrconfig
+anything. This flexibility is good, but it also allows a malicious mrconfig
file to delete your whole home directory. Such a file might be contained
inside a repository that your main ~/.mrconfig checks out and chains to. To
avoid worries about evil commands in a mrconfig file, mr
=head1 AUTHOR
-Copyright 2007-2009 Joey Hess <joey@kitenet.net>
+Copyright 2007-2010 Joey Hess <joey@kitenet.net>
Licensed under the GNU GPL version 2 or higher.
my $verbose=0;
my $quiet=0;
my $stats=0;
+my $insecure=0;
my $interactive=0;
my $max_depth;
my $no_chdir=0;
my $lib=exists $config{$topdir}{$subdir}{lib} ?
$config{$topdir}{$subdir}{lib}."\n" : "";
my $is_checkout=($action eq 'checkout');
+ my $is_update=($action =~ /update/);
$ENV{MR_REPO}=$dir;
$dir=~s/^(.*)\/[^\/]+\/?$/$1/;
}
}
- elsif ($action =~ /update/) {
+ elsif ($is_update) {
if (! -d $dir) {
return action("checkout", $dir, $topdir, $subdir);
}
$s=~s/^\Q$topdir$subdir\E\/?//;
print "mr $action: $topdir$subdir (in subdir $s)\n" unless $quiet;
}
+
+ my $hookret=hook("pre_$action", $topdir, $subdir);
+ return $hookret if $hookret != OK;
+
$command="set -e; ".$lib.
"my_action(){ $command\n }; my_action ".
join(" ", map { s/\//\/\//g; s/"/\"/g; '"'.$_.'"' } @ARGV);
return FAILED;
}
else {
- if ($action eq 'checkout' && ! -d $dir) {
+ if ($is_checkout && ! -d $dir) {
print STDERR "mr $action: $dir missing after checkout\n";;
return FAILED;
}
+ my $ret=hook("post_$action", $topdir, $subdir);
+ return $ret if $ret != OK;
+
+ if (($is_checkout || $is_update)) {
+ my $ret=hook("fixups", $topdir, $subdir);
+ return $ret if $ret != OK;
+ }
+
return OK;
}
}
}
+sub hook {
+ my ($hook, $topdir, $subdir) = @_;
+
+ my $command=$config{$topdir}{$subdir}{$hook};
+ return OK unless defined $command;
+ my $lib=exists $config{$topdir}{$subdir}{lib} ?
+ $config{$topdir}{$subdir}{lib}."\n" : "";
+ my $shell="set -e;".$lib.
+ "my_hook(){ $command\n }; my_hook";
+ print "mr $hook: running >>$shell<<\n" if $verbose;
+ my $ret=system($shell);
+ if ($ret != 0) {
+ if (($? & 127) == 2) {
+ print STDERR "mr $hook: interrupted\n";
+ return ABORT;
+ }
+ elsif ($? & 127) {
+ print STDERR "mr $hook: received signal ".($? & 127)."\n";
+ return ABORT;
+ }
+ }
+
+ return OK;
+}
+
# run actions on multiple repos, in parallel
sub mrs {
my $action=shift;
if ($ret == OK) {
push @ok, $dir;
- print "\n";
+ print "\n" unless $quiet;
}
elsif ($ret == FAILED) {
if ($interactive) {
chdir($dir) unless $no_chdir;
print STDERR "mr: Starting interactive shell. Exit shell to continue.\n";
- system((getpwuid($<))[8]);
+ system((getpwuid($<))[8], "-i");
}
push @failed, $dir;
- print "\n";
+ print "\n" unless $quiet;
}
elsif ($ret == SKIPPED) {
push @skipped, $dir;
} @list;
}
+sub repodir {
+ my $repo=shift;
+ my $topdir=$repo->{topdir};
+ my $subdir=$repo->{subdir};
+ my $ret=($subdir =~/^\//) ? $subdir : $topdir.$subdir;
+ $ret=~s/\/\.$//;
+ return $ret;
+}
+
# figure out which repos to act on
sub selectrepos {
my @repos;
my $subdir=$repo->{subdir};
next if $subdir eq 'DEFAULT';
- my $dir=($subdir =~/^\//) ? $subdir : $topdir.$subdir;
+ my $dir=repodir($repo);
my $d=$directory;
$dir.="/" unless $dir=~/\/$/;
$d.="/" unless $d=~/\/$/;
my $subdir=$repo->{subdir};
next if $subdir eq 'DEFAULT';
- my $dir=($subdir =~/^\//) ? $subdir : $topdir.$subdir;
+ my $dir=repodir($repo);
my $d=$directory;
$dir.="/" unless $dir=~/\/$/;
$d.="/" unless $d=~/\/$/;
open($in, "<", $f) || die "mr: open $f: $!\n";
}
my @lines=<$in>;
- close $in;
+ close $in unless ref $f eq 'GLOB';
my $section;
my $line=0;
}
}
$section=expandenv($section) if $trusted;
+ if ($section ne 'ALIAS' &&
+ ! exists $config{$dir}{$section} &&
+ exists $config{$dir}{DEFAULT}) {
+ # copy in defaults
+ $config{$dir}{$section}={ %{$config{$dir}{DEFAULT}} };
+ }
}
elsif (/^(\w+)\s*=\s*(.*)/) {
my $parameter=$1;
if (! defined $section) {
die "$f line $.: parameter ($parameter) not in section\n";
}
- if ($section ne 'ALIAS' &&
- ! exists $config{$dir}{$section} &&
- exists $config{$dir}{DEFAULT}) {
- # copy in defaults
- $config{$dir}{$section}={ %{$config{$dir}{DEFAULT}} };
- }
if ($section eq 'ALIAS') {
$alias{$parameter}=$value;
}
}
}
+sub startingconfig {
+ %alias=%config=%configfiles=%knownactions=%loaded=();
+ my $datapos=tell(DATA);
+ loadconfig(\*DATA);
+ seek(DATA,$datapos,0); # rewind
+}
+
sub modifyconfig {
my $f=shift;
# the section to modify or add
eval q{use File::Temp};
die $@ if $@;
my $tmpconfig=File::Temp->new();
- if (system("curl", "-A", "mr", "-s", $url, "-o", $tmpconfig) != 0) {
- die "mr: download of $url failed\n";
- }
+ my @curlargs = ("curl", "-A", "mr", "-L", "-s", $url, "-o", $tmpconfig);
+ push(@curlargs, "-k") if $insecure;
+ my $curlstatus = system(@curlargs);
+ die "mr bootstrap: invalid SSL certificate for $url (consider -k)\n" if $curlstatus >> 8 == 60;
+ die "mr bootstrap: download of $url failed\n" if $curlstatus != 0;
if (! -e $dir) {
system("mkdir", "-p", $dir);
if exists $config{$topdir}{"."}{"checkout"};
if (-e ".mrconfig") {
- print STDERR "mr: .mrconfig file already exists, not overwriting with $url\n";
+ print STDERR "mr bootstrap: .mrconfig file already exists, not overwriting with $url\n";
}
else {
- rename($tmpconfig, ".mrconfig") || die "rename: $!";
- }
-
- exec("mr $ENV{MR_SWITCHES} -c .mrconfig checkout");
- die "failed to run mr checkout";
+ eval q{use File::Copy};
+ die $@ if $@;
+ move($tmpconfig, ".mrconfig") || die "rename: $!";
+ }
+
+ # Reload the config file (in case we got a different version)
+ # and checkout everything else.
+ startingconfig();
+ loadconfig(".mrconfig");
+ dispatch("checkout");
+ @skipped=grep { abs_path($_) ne abs_path($topdir) } @skipped;
+ showstats("bootstrap");
+ exitstats();
}
# alias expansion and command stemming
"v|verbose" => \$verbose,
"q|quiet" => \$quiet,
"s|stats" => \$stats,
+ "k|insecure" => \$insecure,
"i|interactive" => \$interactive,
"n|no-recurse:i" => \$max_depth,
"j|jobs:i" => \$jobs,
$ENV{MR_PATH}=$Bin."/".$Script;
};
}
+
+sub exitstats {
+ if (@failed) {
+ exit 1;
+ }
+ elsif (! @ok && @skipped) {
+ exit 1;
+ }
+ else {
+ exit 0;
+ }
+}
sub main {
getopts();
init();
- loadconfig(\*DATA);
+ startingconfig();
loadconfig($ENV{MR_CONFIG});
#use Data::Dumper; print Dumper(\%config);
my $action=expandaction(shift @ARGV);
dispatch($action);
- showstats($action);
- if (@failed) {
- exit 1;
- }
- elsif (! @ok && @skipped) {
- exit 1;
- }
- else {
- exit 0;
- }
+ showstats($action);
+ exitstats();
}
# Finally, some useful actions that mr knows about by default.
if [ -z "$1" ] || [ -z "$2" ]; then
error "mr: usage: hours_since action num"
fi
- for dir in .git .svn .bzr CVS .hg _darcs; do
+ for dir in .git .svn .bzr CVS .hg _darcs _FOSSIL_; do
if [ -e "$MR_REPO/$dir" ]; then
flagfile="$MR_REPO/$dir/.mr_last$1"
break
fi
delta=`perl -wle 'print -f shift() ? int((-M _) * 24) : 9999' "$flagfile"`
if [ "$delta" -lt "$2" ]; then
- exit 0
+ return 1
else
touch "$flagfile"
- exit 1
+ return 0
fi
}
cvs_test = test -d "$MR_REPO"/CVS
hg_test = test -d "$MR_REPO"/.hg
darcs_test = test -d "$MR_REPO"/_darcs
+fossil_test = test -f "$MR_REPO"/_FOSSIL_
git_bare_test =
test -d "$MR_REPO"/refs/heads && test -d "$MR_REPO"/refs/tags &&
test -d "$MR_REPO"/objects && test -f "$MR_REPO"/config &&
cvs_update = cvs update "$@"
hg_update = hg pull "$@" && hg update "$@"
darcs_update = darcs pull -a "$@"
+fossil_update = fossil pull "$@"
svn_status = svn status "$@"
-git_status = git status "$@" || true
-bzr_status = bzr status "$@"
+git_status = git status -s "$@" || true
+bzr_status = bzr status --short "$@"
cvs_status = cvs status "$@"
hg_status = hg status "$@"
darcs_status = darcs whatsnew -ls "$@" || true
+fossil_status = fossil changes "$@"
svn_commit = svn commit "$@"
git_commit = git commit -a "$@" && git push --all
cvs_commit = cvs commit "$@"
hg_commit = hg commit -m "$@" && hg push
darcs_commit = darcs record -a -m "$@" && darcs push -a
+fossil_commit = fossil commit "$@"
git_record = git commit -a "$@"
bzr_record = bzr commit "$@"
hg_record = hg commit -m "$@"
darcs_record = darcs record -a -m "$@"
+fossil_record = fossil commit "$@"
svn_push = :
git_push = git push "$@"
cvs_push = :
hg_push = hg push "$@"
darcs_push = darcs push -a "$@"
+fossil_push = fossil push "$@"
svn_diff = svn diff "$@"
git_diff = git diff "$@"
cvs_diff = cvs diff "$@"
hg_diff = hg diff "$@"
darcs_diff = darcs diff -u "$@"
+fossil_diff = fossil diff "$@"
svn_log = svn log "$@"
git_log = git log "$@"
hg_log = hg log "$@"
darcs_log = darcs changes "$@"
git_bare_log = git log "$@"
+fossil_log = fossil timeline "$@"
svn_register =
url=`LC_ALL=C svn info . | grep -i '^URL:' | cut -d ' ' -f 2`
fi
echo "Registering git url: $url in $MR_CONFIG"
mr -c "$MR_CONFIG" config "`pwd`" checkout="git clone --bare '$url' '$MR_REPO'"
+fossil_register =
+ url=`fossil remote-url`
+ repo=`fossil info | grep repository | sed -e 's/repository:*.//g' -e 's/ //g'`
+ echo "Registering fossil repository $url in $MR_CONFIG"
+ mr -c "$MR_CONFIG" config "`pwd`" checkout="mkdir -p '$MR_REPO' && cd '$MR_REPO' && fossil open '$repo'"
svn_trusted_checkout = svn co $url $repo
svn_alt_trusted_checkout = svn checkout $url $repo
hg_trusted_checkout = hg clone $url $repo
darcs_trusted_checkout = darcs get $url $repo
git_bare_trusted_checkout = git clone --bare $url $repo
+# fossil: messy to do
+
help =
+ case `uname -s` in
+ SunOS)
+ SHOWMANFILE="man -f"
+ ;;
+ Darwin)
+ SHOWMANFILE="man"
+ ;;
+ *)
+ SHOWMANFILE="man -l"
+ ;;
+ esac
if [ ! -e "$MR_PATH" ]; then
error "cannot find program path"
fi
tmp=$(mktemp -t mr.XXXXXXXXXX) || error "mktemp failed"
trap "rm -f $tmp" exit
pod2man -c mr "$MR_PATH" > "$tmp" || error "pod2man failed"
- man -l "$tmp" || error "man failed"
+ $SHOWMANFILE "$tmp" || error "man failed"
list = true
config =
bootstrap =